# Node.js Translate

Node.JS Translate module consumes Google Translate for free.

Node.js Translate module allows to get translation automatically
for text or HTML in many languages.
Node.js Translate works together with this library:
https://www.npmjs.com/package/@iamtraction/google-translate

It ~abuses~ uses Google Translate page via Node.js and
returns translation back to Drupal.
It doesn't need any Google API keys and it's FREE.
Obviously, it's against Google policy.
But you can use this module for learning Drupal and
Node.js or create own pet projects.

## Installation

1. Install as you would normally install a contributed Drupal module.
   For further information, see
   [Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

2. You also need to install Node.js:
   https://nodejs.org/en

3. And run these commands in libraries/google-translate folder:
```
npm install
npm start
```

4. Node.js Translate service will work only if your terminal is working.
   If you need to run it automatically, use PM2 to run process in background
   and startup it automatically.

```
npm install pm2@latest -g
yarn global add pm2
pm2 start index.js
pm2 save
```

## Usage

Use getTranslation() method to translate short stings or texts:
```
\Drupal::service('nodejs_translate.nodejs_translator')->getTranslation($string, $from, $to)
```

Use translateText() method to translate texts longer than 4000 characters:
```
\Drupal::service('nodejs_translate.nodejs_translator')->translateText($text, $from, $to)
```

## Limitations

You can run translate for big texts and need to split HTML/text in chunks
less than 4900 characters. And you need to set up delay between
each translation. Delays must be different, it can't be the same,
because we need to pretend real user behaviour. Node.js Translate has
configuration for delay values.
Also, I couldn't find smart split on chunks to support right splitting
without cutting HTML tags in the middle. Feel free to suggest smart split
library in the module issues.

## Disclaimer

The only way to translate a site is through Google Translate.
Before, the Google TOS only allowed to access the service through
the interface provided by Google.
https://policies.google.com/terms/archive/20070416-20120301?gl=US&hl=en

See point 5.3:

You agree not to access (or attempt to access) any of
the Services by any means other than through the interface
that is provided by Google, unless you have been specifically
allowed to do so in a separate agreement with Google.
You specifically agree not to access (or attempt to access)
any of the Services through any automated means
(including use of scripts or web crawlers) and
shall ensure that you comply with the instructions
set out in any robots.txt file present on the Services.

In short, it's against Google policy, don't use it in real projects.
